#ifndef CELLRENDERER_COLOR_HPP
#define CELLRENDERER_COLOR_HPP 1

#include <gtkmm.h>
//#include <boost/signal.hpp>

//typedef boost::signal <void (const Glib::ustring&, const Gdk::Color&)> ColorSignal ;

class CellRendererColor : public Gtk::CellRendererCombo
{
	friend void CellRendererColor_on_editing_started (
			GtkCellRenderer*, 
			GtkCellEditable* cell_editable, 
			const gchar*,
			void* data
			);

	friend void CellRenderColor_item_changed (CellRendererColor*, Gtk::ComboBox*) ;

	friend void CellRendererColor_on_edited (
			GtkCellRenderer*,
			gchar*,
			gchar*,
			void* data
			);

	struct Columns : public Gtk::TreeModel::ColumnRecord
	{
		Columns ()
		{
			add (m_col1) ;
			add (m_image) ;
			add (m_red) ;
			add (m_green) ;
			add (m_blue) ;
		}

		Gtk::TreeModelColumn <Glib::ustring> m_col1 ;
		Gtk::TreeModelColumn < Glib::RefPtr <Gdk::Pixbuf> > m_image ;
		Gtk::TreeModelColumn < float > m_red, m_green, m_blue ;
	} ;

	public:
		CellRendererColor(Gtk::Widget* parent) ;
		virtual ~CellRendererColor();

		void add_color (const Gdk::Color& c, const Glib::ustring& name) ;
		void remove_all_items (void) ;

		void set_color_changed (bool b) { m_colorChanged = b ; }
		bool get_color_changed (void) { return m_colorChanged ; }

		void send_color_change_signal (const Gtk::TreeIter& iter) ;
		void set_current_color (const Gtk::TreeIter&) ;
		sigc::connection& get_changed_signal (void) { return conn_changed ; }

//		ColorSignal& signal_color_changed (void) 
//		{ return m_colorSignal ; }

	private:
		Columns m_columns ;
		Gtk::Widget* m_parent ;
		Glib::RefPtr<Gtk::ListStore> m_model ;
		sigc::connection conn_changed ;

		guint edited_signal ;
//		ColorSignal m_colorSignal ;
		Gdk::Color m_currentColor ;
		bool m_colorChanged ;

		Glib::RefPtr<Gdk::Pixbuf> create_from_color (const Gdk::Color& c) ;


	protected:
} ;

#endif
